; This is the predecrement and postincrement
; addressing mode without address and data
; registers 0 and 7 moved.


           org         $0
           dc.l        $1ff0
           dc.l        program
           ds.w        $100

program:
           movea.l     #$01100011,a0
           movea.l     #$02200022,a1
           movea.l     #$03300033,a2
           movea.l     #$04400044,a3
           movea.l     #$00001670,a4 ; addressing register.
           movea.l     #$05500055,a5
           movea.l     #$06600066,a6
           movea.l     #$07700077,a7
           move.l      #$08800088,d0
           move.l      #$09900099,d1
           move.l      #$0aa000aa,d2
           move.l      #$0bb000bb,d3
           move.l      #$0cc000cc,d4
           move.l      #$0dd000dd,d5
           move.l      #$0ee000ee,d6
           move.l      #$0ff000ff,d7

           ; pay attention that the addressing register
           ; is written with its decremented value.
           movem.l     d1-d4/d6/a1/a2/a4/a6,-(a4)

           movea.l     #$00000000,a1
           movea.l     #$00000000,a2
           movea.l     #$00000000,a6
           move.l      #$00000000,d1
           move.l      #$00000000,d2
           move.l      #$00000000,d3
           move.l      #$00000000,d4
           move.l      #$00000000,d6

           ; pay attention that the addressing register
           ; is not overwritten.
           movem.l     (a4)+,d1-d4/d6/a1/a2/a4/a6

           movem.w     d1-d4/d6/a1/a2/a4/a6,-(a4)
           movem.w     (a4)+,d1-d4/d6/a1/a2/a4/a6

           stop        #$2700